diff --git a/src/interfaces/ecpg/test/sql/declare.pgc b/src/interfaces/ecpg/test/sql/declare.pgc
new file mode 100644
index 0000000..d3bfb55
--- /dev/null
+++ b/src/interfaces/ecpg/test/sql/declare.pgc
@@ -0,0 +1,1028 @@
+#include <locale.h>
+#include <string.h>
+#include <stdlib.h>
+
+exec sql whenever sqlerror sqlprint;
+
+exec sql include sqlca;
+exec sql include ../regression;
+
+#define OUT_ARRAY_SZIE 20
+#define TEST_CASE_NUM 29
+#define COLUMN_NUM 3
+#define FIELD_NAME_LEN 30
+
+void declare_test(char * tc_name);
+int createTable(void);
+void dropTable(void);
+void reCreateTable(void);
+void truncateTable(void);
+void commitTable(void);
+void reset(void);
+int initValues(void);
+void releaseValues(void);
+void printResultF123(char *tc_name, int loop);
+void printResultIndF123(char *tc_name, int loop);
+int startManualTest(char *in);
+int startAutoTest(void);
+void printFieldName(char *);
+
+EXEC SQL BEGIN DECLARE SECTION;
+
+    //input variables
+    int         in_f1 = 1 ;
+    double      in_f2 = 10;
+    char        in_f3[20] = {"one"};
+
+    //output variables
+    int f1[OUT_ARRAY_SZIE];
+    int f2[OUT_ARRAY_SZIE];
+    char f3[OUT_ARRAY_SZIE][20];
+
+    char field_name[COLUMN_NUM][FIELD_NAME_LEN];
+
+
+    int ind_f1[OUT_ARRAY_SZIE],ind_f2[OUT_ARRAY_SZIE],ind_f3[OUT_ARRAY_SZIE];
+
+EXEC SQL END DECLARE SECTION;
+
+int
+main (int argc, char *argv[])
+{
+    setlocale(LC_ALL, "C");
+
+    ECPGdebug(1, stderr);
+
+    /* connect to database */
+    EXEC SQL CONNECT TO REGRESSDB1 AS con1;
+    EXEC SQL CONNECT TO REGRESSDB2 AS con2;
+    EXEC SQL CONNECT TO REGRESSDB3 as con3;
+
+    if(initValues())
+    {
+        printf("Error: initValues return error!\n");
+
+        releaseValues();
+        return -1;
+    }
+
+    if(argc == 2) //start manual test
+    {
+        printf("Start manual test! \n");
+        startManualTest(argv[1]);
+    }
+    else  //start auto test
+    {
+        startAutoTest();
+    }
+
+    EXEC SQL DISCONNECT con1;
+
+    EXEC SQL DISCONNECT ALL;
+
+    releaseValues();
+
+    return (0);
+}
+
+int startManualTest(char *in)
+{
+    if(!strcmp(in,"cr"))
+    {
+        createTable();
+    }
+    else if(!strcmp(in,"dr"))
+    {
+        dropTable();
+    }
+    else if(!strcmp(in,"re"))
+    {
+        reCreateTable();
+    }
+    else if(!strcmp(in,"help"))
+    {
+        printf("====Supporting the following parameters====\n");
+        printf("1. cr -- create tables\n");
+        printf("2. dr -- drop tables\n");
+        printf("3. re -- drop tables and create tables\n");
+        printf("4. testcaseX where X is a digit form 1 to %d\n",TEST_CASE_NUM);
+        printf("If you don't give any parameter, the program will start the test from the testcase1 to testcase%d automatically\n",TEST_CASE_NUM);
+    }
+    else
+    {
+        declare_test(in);
+    }
+
+    commitTable();
+
+    return 0;
+}
+
+int startAutoTest()
+{
+    int i;
+    char tc_name[20];
+
+    dropTable();
+
+    if(createTable())
+    {
+        printf("Error: createTable return error!\n");
+        return -1;
+    }
+
+    for(i=1;i<=TEST_CASE_NUM;i++)
+    {
+        sprintf(tc_name,"testcase%d",i);
+        declare_test(tc_name);
+    }
+
+    dropTable();
+
+    return 0;
+}
+
+
+/*
+ * default connection: con3
+ * Non-default connection: con1, con2
+ *
+ * testcase1. using DECLARE STATEMENT, let CURSOR statement precede PREPARE statement
+ *        ---test result: ok
+ * testcase2. without using DECLARE STATEMENT, let CURSOR statement precede PREPARE statement
+ *        ---test result: ok
+ *
+ * testcase3. using DECLARE STATEMENT at con1, using PREPARE and EXECUTE statement without using AT clause
+ *        ---test result: ok
+ * testcase4. using DECLARE STATEMENT at con1, using PREPARE and EXECUTE statement at con2
+ *        ---test result: ok
+ * testcase5. using DECLARE STATEMENT at con1, using PREPARE and CURSOR statement without using AT clause
+ *        ---test result: ok
+ * testcase6. using DECLARE STATEMENT at con1, using PREPARE and CURSOR statement at con2
+ *        ---test result: ok
+ * testcase7. using DECLARE STATEMENT at con1, using DESCRIBE statement without using AT clause
+ *        ---test result: ok
+ * testcase8. using DECLARE STATEMENT at con1, using DESCRIBE statement at con2
+ *        ---test result: ok
+ *
+ * testcase9. using DECLARE STATEMENT at con3, using PREPARE and EXECUTE statement without using AT clause
+ *        ---test result: ok
+ * testcase10. using DECLARE STATEMENT at con3, using PREPARE and EXECUTE statement at con2
+ *        ---test result: ok
+ * testcase11. using DECLARE STATEMENT at con3, using PREPARE and CURSOR statement without using AT clause
+ *        ---test result: ok
+ * testcase12. using DECLARE STATEMENT at con3, using PREPARE and CURSOR statement at con2
+ *        ---test result: ok
+ * testcase13. using DECLARE STATEMENT at con3, using DESCRIBE statement without using AT clause
+ *        ---test result: ok
+ * testcase14. using DECLARE STATEMENT at con3, using DESCRIBE statement at con2
+ *        ---test result: ok
+ *
+ * testcase15. using DECLARE STATEMENT without using AT clause, using PREPARE and EXECUTE statement without using AT clause
+ *        ---test result: ok
+ * testcase16. using DECLARE STATEMENT without using AT clause, using PREPARE and EXECUTE statement at con2
+ *        ---test result: ok
+ * testcase17. using DECLARE STATEMENT without using AT clause, using PREPARE and CURSOR statement without using AT clause
+ *        ---test result: ok
+ * testcase18. using DECLARE STATEMENT without using AT clause, using PREPARE and CURSOR statement at con2
+ *        ---test result: ok
+ * testcase19. using DECLARE STATEMENT without using AT clause, using DESCRIBE statement without using AT clause
+ *        ---test result: ok
+ * testcase20. using DECLARE STATEMENT without using AT clause, using DESCRIBE statement at con2
+ *        ---test result: ok
+
+ * testcase21. using DECLARE STATEMENT at con1, using PREPARE and EXECUTE statement at con2
+ *            using quoted string as declared name
+ *        ---test result: ok
+ * testcase22. using DECLARE STATEMENT at con1, using PREPARE and CURSOR statement at con2
+ *            using quoted string as declared name
+ *        ---test result: ok
+ * testcase23. using DECLARE STATEMENT at con1, using DESCRIBE statement at con2
+ *            using quoted string as declared name
+ *        ---test result: ok
+ *
+ * testcase24. using DECLARE STATEMENT at con1, using PREPARE and EXECUTE statement at con2
+ *            using host variable as declared name
+ *        ---test result:
+ *
+ * testcase25. using DECLARE STATEMENT at con1, using PREPARE and EXECUTE statement at con2 and without referring the DECLARE statement
+ *        ---test result: ok
+ * testcase26. using DECLARE STATEMENT at con1, using PREPARE and CURSOR statement at con2 and without referring the DECLARE statement
+ *        ---test result: ok
+ * testcase27. using DECLARE STATEMENT at con1, using PREPARE and DESCRIBE statement at con2 and without referring the DECLARE statement
+ *        ---test result: ok
+ *
+ * testcase28. Using host variable as cursor name in the DECLARE/OPEN CURSOR statement,
+ *             using the content in the host variable as the cursor name in the CLOSE CURSOR statement
+ *             This is nothing with DECLARE STATEMENT feature, this case just verify a bug that cursor name can be closed by using
+ *             content of host variable while the cursor name is declared/opened by using the host variable.
+ *        ---test result: ok
+ *
+ * testcase29. using DECLARE STATEMENT at con1, using PREPARE and CURSOR statement without using AT clause
+ *             one cursor is set to "open" and "close" twice.
+ *             Check the declared name can be referred by the cursor at the second time correctly
+ *        ---test result: ok
+ */
+void declare_test(char * tc_name)
+{
+    EXEC SQL BEGIN DECLARE SECTION;
+    int i;
+
+    char    *selectString = "SELECT f1,f2,f3 FROM source where f1<4";
+    char    *selectTb1 = "SELECT * FROM tb1";
+
+    char    *stmt_4 = "str_stmt_4";
+    char    *stmt_6 = "str_stmt_6";
+    char    *stmt_8 = "str_stmt_8";
+
+    char    *cur_6 = "str_cur_6";
+
+    char    *desc_8 = "str_desc_8";
+
+    EXEC SQL END DECLARE SECTION;
+
+    if(!strcmp(tc_name,"testcase1"))
+    {
+        reset();
+
+        EXEC SQL DECLARE stmt_1 STATEMENT;
+        EXEC SQL DECLARE cur_1 CURSOR FOR stmt_1;
+        EXEC SQL PREPARE stmt_1 FROM :selectString;
+        EXEC SQL OPEN cur_1;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL FETCH cur_1 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL CLOSE cur_1;
+        EXEC SQL DEALLOCATE PREPARE stmt_1;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase2"))
+    {
+        reset();
+
+        EXEC SQL DECLARE cur_2 CURSOR FOR stmt_2;
+        EXEC SQL PREPARE stmt_2 FROM :selectString;
+        EXEC SQL OPEN cur_2;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL FETCH cur_2 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL CLOSE cur_2;
+        EXEC SQL DEALLOCATE PREPARE stmt_2;
+
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase3"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE stmt_3 STATEMENT;
+        EXEC SQL PREPARE stmt_3 FROM :selectString;
+        EXEC SQL EXECUTE stmt_3 INTO :f1,:f2,:f3;
+
+        EXEC SQL DEALLOCATE PREPARE stmt_3;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase4"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE stmt_4 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_4 FROM :selectString;
+        EXEC SQL AT con2 EXECUTE stmt_4 INTO :f1,:f2,:f3;
+
+        EXEC SQL DEALLOCATE PREPARE stmt_4;
+
+        printResultF123(tc_name,3);
+
+        reset();
+
+        EXEC SQL AT con1 DECLARE :stmt_4 STATEMENT;
+        EXEC SQL AT con2 PREPARE :stmt_4 FROM :selectString;
+        EXEC SQL AT con2 EXECUTE :stmt_4 INTO :f1,:f2,:f3;
+
+        EXEC SQL DEALLOCATE PREPARE :stmt_4;
+
+        printResultF123(NULL,3);
+    }
+    else if(!strcmp(tc_name,"testcase5"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE stmt_5 STATEMENT;
+        EXEC SQL PREPARE stmt_5 FROM :selectString;
+        EXEC SQL DECLARE cur_5 CURSOR FOR stmt_5;
+        EXEC SQL OPEN cur_5;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL FETCH cur_5 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL CLOSE cur_5;
+        EXEC SQL DEALLOCATE PREPARE stmt_5;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase6"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE stmt_6 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_6 FROM :selectString;
+        EXEC SQL AT con2 DECLARE cur_6 CURSOR FOR stmt_6;
+        EXEC SQL AT con2 OPEN cur_6;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL AT con2 FETCH cur_6 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL AT con2 CLOSE cur_6;
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_6;
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(tc_name,3);
+
+        reset();
+
+        EXEC SQL AT con1 DECLARE :stmt_6 STATEMENT;
+        EXEC SQL AT con2 PREPARE :stmt_6 FROM :selectString;
+        EXEC SQL AT con2 DECLARE :cur_6 CURSOR FOR :stmt_6;
+        EXEC SQL AT con2 OPEN :cur_6;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL AT con2 FETCH :cur_6 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL AT con2 CLOSE :cur_6;
+        EXEC SQL AT con2 DEALLOCATE PREPARE :stmt_6;
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(NULL,3);
+    }
+    else if(!strcmp(tc_name,"testcase7"))
+    {
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR desc_7;
+
+        EXEC SQL AT con1 DECLARE stmt_7 STATEMENT;
+        EXEC SQL PREPARE stmt_7 FROM :selectTb1;
+        EXEC SQL DESCRIBE stmt_7 into SQL DESCRIPTOR desc_7;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR desc_7 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR desc_7;
+        EXEC SQL DEALLOCATE PREPARE stmt_7;
+
+        printFieldName(tc_name);
+    }
+    else if(!strcmp(tc_name,"testcase8"))
+    {
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR desc_8;
+
+        EXEC SQL AT con1 DECLARE stmt_8 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_8 FROM :selectTb1;
+        EXEC SQL AT con2 DESCRIBE stmt_8 into SQL DESCRIPTOR desc_8;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR desc_8 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR desc_8;
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_8;
+
+        printFieldName(tc_name);
+
+
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR :desc_8;
+
+        EXEC SQL AT con1 DECLARE :stmt_8 STATEMENT;
+        EXEC SQL AT con2 PREPARE :stmt_8 FROM :selectTb1;
+        EXEC SQL AT con2 DESCRIBE :stmt_8 into SQL DESCRIPTOR :desc_8;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR :desc_8 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR :desc_8;
+        EXEC SQL AT con2 DEALLOCATE PREPARE :stmt_8;
+
+        printFieldName(NULL);
+    }
+    else if(!strcmp(tc_name,"testcase9"))
+    {
+        reset();
+
+        EXEC SQL AT con3 DECLARE stmt_9 STATEMENT;
+        EXEC SQL PREPARE stmt_9 FROM :selectString;
+        EXEC SQL EXECUTE stmt_9 INTO :f1,:f2,:f3;
+
+        EXEC SQL DEALLOCATE PREPARE stmt_9;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase10"))
+    {
+        reset();
+
+        EXEC SQL AT con3 DECLARE stmt_10 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_10 FROM :selectString;
+        EXEC SQL AT con2 EXECUTE stmt_10 INTO :f1,:f2,:f3;
+
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_10;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase11"))
+    {
+        reset();
+
+        EXEC SQL AT con3 DECLARE stmt_11 STATEMENT;
+        EXEC SQL PREPARE stmt_11 FROM :selectString;
+        EXEC SQL DECLARE cur_11 CURSOR FOR stmt_11;
+        EXEC SQL OPEN cur_11;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL FETCH cur_11 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL CLOSE cur_11;
+        EXEC SQL DEALLOCATE PREPARE stmt_11;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase12"))
+    {
+        reset();
+
+        EXEC SQL AT con3 DECLARE stmt_12 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_12 FROM :selectString;
+        EXEC SQL AT con2 DECLARE cur_12 CURSOR FOR stmt_12;
+        EXEC SQL AT con2 OPEN cur_12;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL AT con2 FETCH cur_12 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL AT con2 CLOSE cur_12;
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_12;
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase13"))
+    {
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR desc_13;
+
+        EXEC SQL AT con3 DECLARE stmt_13 STATEMENT;
+        EXEC SQL PREPARE stmt_13 FROM :selectTb1;
+        EXEC SQL DESCRIBE stmt_13 into SQL DESCRIPTOR desc_13;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR desc_13 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR desc_13;
+        EXEC SQL DEALLOCATE PREPARE stmt_13;
+
+        printFieldName(tc_name);
+    }
+    else if(!strcmp(tc_name,"testcase14"))
+    {
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR desc_14;
+
+        EXEC SQL AT con3 DECLARE stmt_14 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_14 FROM :selectTb1;
+        EXEC SQL AT con2 DESCRIBE stmt_14 into SQL DESCRIPTOR desc_14;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR desc_14 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR desc_14;
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_14;
+
+        printFieldName(tc_name);
+    }
+    else if(!strcmp(tc_name,"testcase15"))
+    {
+        reset();
+
+        EXEC SQL DECLARE stmt_15 STATEMENT;
+        EXEC SQL PREPARE stmt_15 FROM :selectString;
+        EXEC SQL EXECUTE stmt_15 INTO :f1,:f2,:f3;
+
+        EXEC SQL DEALLOCATE PREPARE stmt_15;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase16"))
+    {
+        reset();
+
+        EXEC SQL DECLARE stmt_16 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_16 FROM :selectString;
+        EXEC SQL AT con2 EXECUTE stmt_16 INTO :f1,:f2,:f3;
+
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_16;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase17"))
+    {
+        reset();
+
+        EXEC SQL DECLARE stmt_17 STATEMENT;
+        EXEC SQL PREPARE stmt_17 FROM :selectString;
+        EXEC SQL DECLARE cur_17 CURSOR FOR stmt_17;
+        EXEC SQL OPEN cur_17;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL FETCH cur_17 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL CLOSE cur_17;
+        EXEC SQL DEALLOCATE PREPARE stmt_17;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase18"))
+    {
+        reset();
+
+        EXEC SQL DECLARE stmt_18 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_18 FROM :selectString;
+        EXEC SQL AT con2 DECLARE cur_18 CURSOR FOR stmt_18;
+        EXEC SQL AT con2 OPEN cur_18;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL AT con2 FETCH cur_18 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL AT con2 CLOSE cur_18;
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_18;
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase19"))
+    {
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR desc_19;
+
+        EXEC SQL DECLARE stmt_19 STATEMENT;
+        EXEC SQL PREPARE stmt_19 FROM :selectTb1;
+        EXEC SQL DESCRIBE stmt_19 into SQL DESCRIPTOR desc_19;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR desc_19 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR desc_19;
+        EXEC SQL DEALLOCATE PREPARE stmt_19;
+
+        printFieldName(tc_name);
+    }
+    else if(!strcmp(tc_name,"testcase20"))
+    {
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR desc_20;
+
+        EXEC SQL DECLARE stmt_20 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_20 FROM :selectTb1;
+        EXEC SQL AT con2 DESCRIBE stmt_20 into SQL DESCRIPTOR desc_20;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR desc_20 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR desc_20;
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_20;
+
+        printFieldName(tc_name);
+    }
+    else if(!strcmp(tc_name,"testcase21"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE "stmt_21" STATEMENT;
+        EXEC SQL AT con2 PREPARE "stmt_21" FROM :selectString;
+        EXEC SQL AT con2 EXECUTE "stmt_21" INTO :f1,:f2,:f3;
+
+        EXEC SQL DEALLOCATE PREPARE "stmt_21";
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase22"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE "stmt_22" STATEMENT;
+        EXEC SQL AT con2 PREPARE "stmt_22" FROM :selectString;
+        EXEC SQL AT con2 DECLARE "cur_22" CURSOR FOR "stmt_22";
+        EXEC SQL AT con2 OPEN "cur_22";
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL AT con2 FETCH "cur_22" INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL AT con2 CLOSE "cur_22";
+        EXEC SQL AT con2 DEALLOCATE PREPARE "stmt_22";
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase23"))
+    {
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR desc_23;
+
+        EXEC SQL AT con1 DECLARE "stmt_23" STATEMENT;
+        EXEC SQL AT con2 PREPARE "stmt_23" FROM :selectTb1;
+        EXEC SQL AT con2 DESCRIBE "stmt_23" into SQL DESCRIPTOR desc_23;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR desc_23 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR desc_23;
+        EXEC SQL AT con2 DEALLOCATE PREPARE "stmt_23";
+
+        printFieldName(tc_name);
+    }
+    else if(!strcmp(tc_name,"testcase24"))
+    {
+        EXEC SQL BEGIN DECLARE SECTION;
+        char *char_stmt_24 = "strSTMT24";
+        EXEC SQL END DECLARE SECTION;
+
+        reset();
+
+        EXEC SQL AT con1 DECLARE :char_stmt_24 STATEMENT;
+        EXEC SQL AT con2 PREPARE :char_stmt_24 FROM :selectString;
+        EXEC SQL AT con2 EXECUTE :char_stmt_24 INTO :f1,:f2,:f3;
+
+        EXEC SQL DEALLOCATE PREPARE :char_stmt_24;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase25"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE stmt_25 STATEMENT;
+        EXEC SQL AT con2 PREPARE pre_stmt_25 FROM :selectString;
+        EXEC SQL AT con2 EXECUTE pre_stmt_25 INTO :f1,:f2,:f3;
+
+        EXEC SQL AT con2 DEALLOCATE PREPARE pre_stmt_25;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase26"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE stmt_26 STATEMENT;
+        EXEC SQL AT con2 PREPARE pre_stmt_26 FROM :selectString;
+        EXEC SQL AT con2 DECLARE cur_26 CURSOR FOR pre_stmt_26;
+        EXEC SQL AT con2 OPEN cur_26;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL AT con2 FETCH cur_26 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL AT con2 CLOSE cur_26;
+        EXEC SQL AT con2 DEALLOCATE PREPARE pre_stmt_26;
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(tc_name,3);
+    }
+    else if(!strcmp(tc_name,"testcase27"))
+    {
+        reset();
+
+        EXEC SQL ALLOCATE DESCRIPTOR desc_27;
+
+        EXEC SQL AT con1 DECLARE stmt_27 STATEMENT;
+        EXEC SQL AT con2 PREPARE pre_stmt_27 FROM :selectTb1;
+        EXEC SQL AT con2 DESCRIBE pre_stmt_27 into SQL DESCRIPTOR desc_27;
+
+        for(i=1; i<4; i++)
+        {
+            EXEC SQL GET DESCRIPTOR desc_27 value :i :field_name[i-1] = name;
+        }
+
+        EXEC SQL DEALLOCATE DESCRIPTOR desc_27;
+        EXEC SQL AT con2 DEALLOCATE PREPARE pre_stmt_27;
+
+        printFieldName(tc_name);
+    }
+    else if(!strcmp(tc_name,"testcase28"))
+    {
+        EXEC SQL BEGIN DECLARE SECTION;
+        char    *cur_28 = "str_cur_28";
+        EXEC SQL END DECLARE SECTION;
+
+        reset();
+
+        EXEC SQL AT con1 DECLARE stmt_28 STATEMENT;
+        EXEC SQL AT con2 PREPARE stmt_28 FROM :selectString;
+        EXEC SQL AT con2 DECLARE :cur_28 CURSOR FOR stmt_28;
+        EXEC SQL AT con2 OPEN :cur_28;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL AT con2 FETCH :cur_28 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL AT con2 CLOSE str_cur_28;
+        EXEC SQL AT con2 DEALLOCATE PREPARE stmt_28;
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(tc_name,3);
+
+    }
+    else if(!strcmp(tc_name,"testcase29"))
+    {
+        reset();
+
+        EXEC SQL AT con1 DECLARE stmt_29 STATEMENT;
+        EXEC SQL PREPARE stmt_29 FROM :selectString;
+        EXEC SQL DECLARE cur_29 CURSOR FOR stmt_29;
+
+        EXEC SQL OPEN cur_29;
+
+        EXEC SQL WHENEVER NOT FOUND DO BREAK;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL FETCH cur_29 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL CLOSE cur_29;
+        printResultF123(tc_name,3);
+
+        reset();
+        /* Open and fetch cursor again */
+        EXEC SQL OPEN cur_29;
+        i = 0;
+        while(1)
+        {
+            EXEC SQL FETCH cur_29 INTO :f1[i],:f2[i],:f3[i];
+            i++;
+        }
+
+        EXEC SQL CLOSE cur_29;
+        EXEC SQL DEALLOCATE PREPARE stmt_29;
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+
+        printResultF123(NULL,3);
+    }
+    else
+    {
+        EXEC SQL WHENEVER NOT FOUND CONTINUE;
+        printf("Sorry, there isn't this testcase: %s!\n",tc_name);
+    }
+}
+
+
+/*
+ * success -- 0
+ * failed -- -1
+ */
+int createTable()
+{
+    EXEC SQL AT con1 CREATE TABLE source (f1 integer, f2 integer, f3 varchar(20));
+    EXEC SQL AT con2 CREATE TABLE source (f1 integer, f2 integer, f3 varchar(20));
+    EXEC SQL AT con3 CREATE TABLE source (f1 integer, f2 integer, f3 varchar(20));
+
+    EXEC SQL AT con1 CREATE TABLE tb1 (con1_f1 integer, con1_f2 integer, con1_f3 varchar(20));
+    EXEC SQL AT con2 CREATE TABLE tb1 (con2_f1 integer, con2_f2 integer, con2_f3 varchar(20));
+    EXEC SQL AT con3 CREATE TABLE tb1 (con3_f1 integer, con3_f2 integer, con3_f3 varchar(20));
+
+    EXEC SQL AT con1 CREATE TABLE target (f1 integer, f2 integer, f3 varchar(20));
+    EXEC SQL AT con2 CREATE TABLE target (f1 integer, f2 integer, f3 varchar(20));
+    EXEC SQL AT con3 CREATE TABLE target (f1 integer, f2 integer, f3 varchar(20));
+
+
+
+    EXEC SQL AT con1 INSERT INTO source VALUES(1,10,'db on con1');
+    EXEC SQL AT con1 INSERT INTO source VALUES(2,20,'db on con1');
+    EXEC SQL AT con1 INSERT INTO source VALUES(3,30,'db on con1');
+
+    EXEC SQL AT con2 INSERT INTO source VALUES(1,10,'db on con2');
+    EXEC SQL AT con2 INSERT INTO source VALUES(2,20,'db on con2');
+    EXEC SQL AT con2 INSERT INTO source VALUES(3,30,'db on con2');
+
+    EXEC SQL AT con3 INSERT INTO source VALUES(1,10,'db on con3');
+    EXEC SQL AT con3 INSERT INTO source VALUES(2,20,'db on con3');
+    EXEC SQL AT con3 INSERT INTO source VALUES(3,30,'db on con3');
+
+    commitTable();
+
+    return 0;
+}
+
+/*
+ * success -- 0
+ * failed -- -1
+ */
+void dropTable()
+{
+    EXEC SQL AT con1 DROP TABLE IF EXISTS source;
+    EXEC SQL AT con2 DROP TABLE IF EXISTS source;
+    EXEC SQL AT con3 DROP TABLE IF EXISTS source;
+
+    EXEC SQL AT con1 DROP TABLE IF EXISTS target;
+    EXEC SQL AT con2 DROP TABLE IF EXISTS target;
+    EXEC SQL AT con3 DROP TABLE IF EXISTS target;
+
+    EXEC SQL AT con1 DROP TABLE IF EXISTS tb1;
+    EXEC SQL AT con2 DROP TABLE IF EXISTS tb1;
+    EXEC SQL AT con3 DROP TABLE IF EXISTS tb1;
+
+    commitTable();
+}
+
+void reCreateTable()
+{
+    dropTable();
+    createTable();
+}
+
+void truncateTable()
+{
+    EXEC SQL AT con1 TRUNCATE TABLE target;
+    EXEC SQL AT con2 TRUNCATE TABLE target;
+    EXEC SQL AT con3 TRUNCATE TABLE target;
+
+    commitTable();
+}
+
+void commitTable()
+{
+    EXEC SQL AT con1 COMMIT;
+    EXEC SQL AT con2 COMMIT;
+    EXEC SQL AT con3 COMMIT;
+}
+
+/*
+ * reset all the output variables
+ */
+void reset()
+{
+    int i;
+
+    truncateTable();
+
+    memset(f1,0,sizeof(f1));
+    memset(f2,0,sizeof(f2));
+    memset(f3,0,sizeof(f3));
+
+    for(i=0; i<COLUMN_NUM; i++)
+    {
+        memset(field_name[i],0, FIELD_NAME_LEN);
+    }
+}
+
+int initValues()
+{
+    return 0;
+}
+
+void releaseValues()
+{
+}
+
+void printResultF123(char *tc_name, int loop)
+{
+    int i;
+
+    if(loop>OUT_ARRAY_SZIE)
+    {
+        loop = OUT_ARRAY_SZIE;
+    }
+
+    if(tc_name)
+    {
+        printf("****%s test results:****\n",tc_name);
+    }
+
+    for (i = 0; i < loop; i++)
+        printf("f1=%d, f2=%d, f3=%s\n", f1[i], f2[i], f3[i]);
+
+    printf("\n");
+}
+
+void printResultIndF123(char *tc_name, int loop)
+{
+    int i;
+
+    if(loop>OUT_ARRAY_SZIE)
+    {
+        loop = OUT_ARRAY_SZIE;
+    }
+
+    if(tc_name)
+    {
+        printf("****%s indicator results:****\n",tc_name);
+    }
+
+    for (i = 0; i < loop; i++)
+        printf("ind_f1=%d, ind_f2=%d, ind_f3=%d\n", ind_f1[i], ind_f2[i], ind_f3[i]);
+
+    printf("\n");
+}
+
+void printFieldName(char *tc_name)
+{
+    int i;
+
+    if(tc_name)
+    {
+        printf("****%s test results:****\n",tc_name);
+    }
+
+    for (i = 0; i < COLUMN_NUM; i++)
+    {
+        printf("field[%d]'s name = %s\n", i, field_name[i]);
+    }
+
+    printf("\n");
+}
